/* xnoise-tag-writer.c generated by valac, the Vala compiler
 * generated from xnoise-tag-writer.vala, do not modify */

/* xnoise-tag-writer.vala
 *
 * Copyright (C) 2009-2013  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <taginfo_c.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gobject/gvaluecollector.h>


#define XNOISE_TAG_ACCESS_TYPE_TAG_WRITER (xnoise_tag_access_tag_writer_get_type ())
#define XNOISE_TAG_ACCESS_TAG_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TAG_ACCESS_TYPE_TAG_WRITER, XnoiseTagAccessTagWriter))
#define XNOISE_TAG_ACCESS_TAG_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TAG_ACCESS_TYPE_TAG_WRITER, XnoiseTagAccessTagWriterClass))
#define XNOISE_TAG_ACCESS_IS_TAG_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TAG_ACCESS_TYPE_TAG_WRITER))
#define XNOISE_TAG_ACCESS_IS_TAG_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TAG_ACCESS_TYPE_TAG_WRITER))
#define XNOISE_TAG_ACCESS_TAG_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TAG_ACCESS_TYPE_TAG_WRITER, XnoiseTagAccessTagWriterClass))

typedef struct _XnoiseTagAccessTagWriter XnoiseTagAccessTagWriter;
typedef struct _XnoiseTagAccessTagWriterClass XnoiseTagAccessTagWriterClass;
typedef struct _XnoiseTagAccessTagWriterPrivate XnoiseTagAccessTagWriterPrivate;

#define XNOISE_TYPE_TRACK_DATA (xnoise_track_data_get_type ())
#define XNOISE_TRACK_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_TRACK_DATA, XnoiseTrackData))
#define XNOISE_TRACK_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_TRACK_DATA, XnoiseTrackDataClass))
#define XNOISE_IS_TRACK_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_TRACK_DATA))
#define XNOISE_IS_TRACK_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_TRACK_DATA))
#define XNOISE_TRACK_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_TRACK_DATA, XnoiseTrackDataClass))

typedef struct _XnoiseTrackData XnoiseTrackData;
typedef struct _XnoiseTrackDataClass XnoiseTrackDataClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _taginfo_info_free0(var) ((var == NULL) ? NULL : (var = (taginfo_info_free (var), NULL)))
typedef struct _XnoiseTrackDataPrivate XnoiseTrackDataPrivate;

#define XNOISE_TYPE_ITEM (xnoise_item_get_type ())

#define XNOISE_TYPE_ITEM_TYPE (xnoise_item_type_get_type ())
typedef struct _XnoiseItem XnoiseItem;
typedef struct _XnoiseTagAccessParamSpecTagWriter XnoiseTagAccessParamSpecTagWriter;

struct _XnoiseTagAccessTagWriter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XnoiseTagAccessTagWriterPrivate * priv;
};

struct _XnoiseTagAccessTagWriterClass {
	GTypeClass parent_class;
	void (*finalize) (XnoiseTagAccessTagWriter *self);
};

typedef enum  {
	XNOISE_ITEM_TYPE_UNKNOWN = 0,
	XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK,
	XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK,
	XNOISE_ITEM_TYPE_STREAM,
	XNOISE_ITEM_TYPE_CDROM_TRACK,
	XNOISE_ITEM_TYPE_PLAYLIST,
	XNOISE_ITEM_TYPE_LOCAL_FOLDER,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUMARTIST,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_GENRE,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_YEAR,
	XNOISE_ITEM_TYPE_LOADER
} XnoiseItemType;

struct _XnoiseItem {
	XnoiseItemType type;
	guint32 stamp;
	gint32 db_id;
	gchar* uri;
	gchar* text;
	gchar* text2;
	gint source_id;
};

struct _XnoiseTrackData {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XnoiseTrackDataPrivate * priv;
	gchar* artist;
	gchar* albumartist;
	gchar* album;
	gchar* title;
	gchar* genre;
	gchar* name;
	gchar* media_folder;
	gchar* mimetype;
	gint disk_number;
	guint year;
	guint tracknumber;
	gint32 length;
	gint bitrate;
	gboolean is_compilation;
	gboolean has_embedded_image;
	XnoiseItem* item;
	GdkPixbuf* pixbuf;
	gint32 change_time;
	gint32 dat1;
	gint32 dat2;
	gint32 dat3;
};

struct _XnoiseTrackDataClass {
	GTypeClass parent_class;
	void (*finalize) (XnoiseTrackData *self);
};

struct _XnoiseTagAccessParamSpecTagWriter {
	GParamSpec parent_instance;
};


static gpointer xnoise_tag_access_tag_writer_parent_class = NULL;

gpointer xnoise_tag_access_tag_writer_ref (gpointer instance);
void xnoise_tag_access_tag_writer_unref (gpointer instance);
GParamSpec* xnoise_tag_access_param_spec_tag_writer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void xnoise_tag_access_value_set_tag_writer (GValue* value, gpointer v_object);
void xnoise_tag_access_value_take_tag_writer (GValue* value, gpointer v_object);
gpointer xnoise_tag_access_value_get_tag_writer (const GValue* value);
GType xnoise_tag_access_tag_writer_get_type (void) G_GNUC_CONST;
enum  {
	XNOISE_TAG_ACCESS_TAG_WRITER_DUMMY_PROPERTY
};
gpointer xnoise_track_data_ref (gpointer instance);
void xnoise_track_data_unref (gpointer instance);
GParamSpec* xnoise_param_spec_track_data (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void xnoise_value_set_track_data (GValue* value, gpointer v_object);
void xnoise_value_take_track_data (GValue* value, gpointer v_object);
gpointer xnoise_value_get_track_data (const GValue* value);
GType xnoise_track_data_get_type (void) G_GNUC_CONST;
gboolean xnoise_tag_access_tag_writer_write_tag (GFile* file, XnoiseTrackData* td, gboolean read_before_write);
GType xnoise_item_get_type (void) G_GNUC_CONST;
GType xnoise_item_type_get_type (void) G_GNUC_CONST;
XnoiseItem* xnoise_item_dup (const XnoiseItem* self);
void xnoise_item_free (XnoiseItem* self);
void xnoise_item_copy (const XnoiseItem* self, XnoiseItem* dest);
void xnoise_item_destroy (XnoiseItem* self);
#define XNOISE_RESOURCES_EMPTYSTRING ""
gboolean xnoise_tag_access_tag_writer_remove_compilation_flag (GFile* file);
XnoiseTagAccessTagWriter* xnoise_tag_access_tag_writer_new (void);
XnoiseTagAccessTagWriter* xnoise_tag_access_tag_writer_construct (GType object_type);
static void xnoise_tag_access_tag_writer_finalize (XnoiseTagAccessTagWriter* obj);


gboolean xnoise_tag_access_tag_writer_write_tag (GFile* file, XnoiseTrackData* td, gboolean read_before_write) {
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	XnoiseTrackData* _tmp1_ = NULL;
	gboolean retval = FALSE;
	gchar* path = NULL;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	TagInfo_Info* info = NULL;
	const gchar* _tmp5_ = NULL;
	TagInfo_Info* _tmp6_ = NULL;
	TagInfo_Info* _tmp7_ = NULL;
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
	g_return_val_if_fail ((td == NULL) || XNOISE_IS_TRACK_DATA (td), FALSE);
	_tmp0_ = file;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = td;
	if (_tmp1_ == NULL) {
		result = FALSE;
		return result;
	}
	retval = FALSE;
	path = NULL;
	_tmp2_ = file;
	_tmp3_ = g_file_get_path (_tmp2_);
	_g_free0 (path);
	path = _tmp3_;
	_tmp4_ = path;
	if (_tmp4_ == NULL) {
		result = FALSE;
		_g_free0 (path);
		return result;
	}
	info = NULL;
	_tmp5_ = path;
	_tmp6_ = taginfo_info_create (_tmp5_);
	_taginfo_info_free0 (info);
	info = _tmp6_;
	_tmp7_ = info;
	if (_tmp7_ != NULL) {
		gboolean _tmp8_ = FALSE;
		const gchar* _tmp10_ = NULL;
		XnoiseTrackData* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		TagInfo_Info* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		XnoiseTrackData* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		TagInfo_Info* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		const gchar* _tmp24_ = NULL;
		XnoiseTrackData* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
		TagInfo_Info* _tmp29_ = NULL;
		const gchar* _tmp30_ = NULL;
		const gchar* _tmp31_ = NULL;
		XnoiseTrackData* _tmp32_ = NULL;
		const gchar* _tmp33_ = NULL;
		TagInfo_Info* _tmp36_ = NULL;
		const gchar* _tmp37_ = NULL;
		const gchar* _tmp38_ = NULL;
		XnoiseTrackData* _tmp39_ = NULL;
		const gchar* _tmp40_ = NULL;
		TagInfo_Info* _tmp43_ = NULL;
		const gchar* _tmp44_ = NULL;
		XnoiseTrackData* _tmp45_ = NULL;
		guint _tmp46_ = 0U;
		TagInfo_Info* _tmp48_ = NULL;
		XnoiseTrackData* _tmp49_ = NULL;
		guint _tmp50_ = 0U;
		XnoiseTrackData* _tmp51_ = NULL;
		guint _tmp52_ = 0U;
		TagInfo_Info* _tmp54_ = NULL;
		XnoiseTrackData* _tmp55_ = NULL;
		guint _tmp56_ = 0U;
		XnoiseTrackData* _tmp57_ = NULL;
		gint _tmp58_ = 0;
		TagInfo_Info* _tmp60_ = NULL;
		XnoiseTrackData* _tmp61_ = NULL;
		gint _tmp62_ = 0;
		TagInfo_Info* _tmp63_ = NULL;
		XnoiseTrackData* _tmp64_ = NULL;
		gboolean _tmp65_ = FALSE;
		TagInfo_Info* _tmp66_ = NULL;
		gboolean _tmp67_ = FALSE;
		_tmp8_ = read_before_write;
		if (_tmp8_) {
			TagInfo_Info* _tmp9_ = NULL;
			_tmp9_ = info;
			taginfo_info_load (_tmp9_);
		}
		_tmp11_ = td;
		_tmp12_ = _tmp11_->artist;
		if (_tmp12_ != NULL) {
			XnoiseTrackData* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			_tmp13_ = td;
			_tmp14_ = _tmp13_->artist;
			_tmp10_ = _tmp14_;
		} else {
			_tmp10_ = XNOISE_RESOURCES_EMPTYSTRING;
		}
		_tmp15_ = info;
		_tmp16_ = _tmp10_;
		taginfo_info_set_artist (_tmp15_, _tmp16_);
		_tmp18_ = td;
		_tmp19_ = _tmp18_->title;
		if (_tmp19_ != NULL) {
			XnoiseTrackData* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
			_tmp20_ = td;
			_tmp21_ = _tmp20_->title;
			_tmp17_ = _tmp21_;
		} else {
			_tmp17_ = XNOISE_RESOURCES_EMPTYSTRING;
		}
		_tmp22_ = info;
		_tmp23_ = _tmp17_;
		taginfo_info_set_title (_tmp22_, _tmp23_);
		_tmp25_ = td;
		_tmp26_ = _tmp25_->album;
		if (_tmp26_ != NULL) {
			XnoiseTrackData* _tmp27_ = NULL;
			const gchar* _tmp28_ = NULL;
			_tmp27_ = td;
			_tmp28_ = _tmp27_->album;
			_tmp24_ = _tmp28_;
		} else {
			_tmp24_ = XNOISE_RESOURCES_EMPTYSTRING;
		}
		_tmp29_ = info;
		_tmp30_ = _tmp24_;
		taginfo_info_set_album (_tmp29_, _tmp30_);
		_tmp32_ = td;
		_tmp33_ = _tmp32_->albumartist;
		if (_tmp33_ != NULL) {
			XnoiseTrackData* _tmp34_ = NULL;
			const gchar* _tmp35_ = NULL;
			_tmp34_ = td;
			_tmp35_ = _tmp34_->albumartist;
			_tmp31_ = _tmp35_;
		} else {
			_tmp31_ = XNOISE_RESOURCES_EMPTYSTRING;
		}
		_tmp36_ = info;
		_tmp37_ = _tmp31_;
		taginfo_info_set_albumartist (_tmp36_, _tmp37_);
		_tmp39_ = td;
		_tmp40_ = _tmp39_->genre;
		if (_tmp40_ != NULL) {
			XnoiseTrackData* _tmp41_ = NULL;
			const gchar* _tmp42_ = NULL;
			_tmp41_ = td;
			_tmp42_ = _tmp41_->genre;
			_tmp38_ = _tmp42_;
		} else {
			_tmp38_ = XNOISE_RESOURCES_EMPTYSTRING;
		}
		_tmp43_ = info;
		_tmp44_ = _tmp38_;
		taginfo_info_set_genre (_tmp43_, _tmp44_);
		_tmp45_ = td;
		_tmp46_ = _tmp45_->year;
		if (_tmp46_ < ((guint) 0)) {
			XnoiseTrackData* _tmp47_ = NULL;
			_tmp47_ = td;
			_tmp47_->year = (guint) 0;
		}
		_tmp48_ = info;
		_tmp49_ = td;
		_tmp50_ = _tmp49_->year;
		taginfo_info_set_year (_tmp48_, (gint) _tmp50_);
		_tmp51_ = td;
		_tmp52_ = _tmp51_->tracknumber;
		if (_tmp52_ < ((guint) 0)) {
			XnoiseTrackData* _tmp53_ = NULL;
			_tmp53_ = td;
			_tmp53_->tracknumber = (guint) 0;
		}
		_tmp54_ = info;
		_tmp55_ = td;
		_tmp56_ = _tmp55_->tracknumber;
		taginfo_info_set_track_number (_tmp54_, (gint) _tmp56_);
		_tmp57_ = td;
		_tmp58_ = _tmp57_->disk_number;
		if (_tmp58_ < 1) {
			XnoiseTrackData* _tmp59_ = NULL;
			_tmp59_ = td;
			_tmp59_->disk_number = 1;
		}
		_tmp60_ = info;
		_tmp61_ = td;
		_tmp62_ = _tmp61_->disk_number;
		taginfo_info_set_volume_number (_tmp60_, (gint) _tmp62_);
		_tmp63_ = info;
		_tmp64_ = td;
		_tmp65_ = _tmp64_->is_compilation;
		taginfo_info_set_is_compilation (_tmp63_, _tmp65_);
		_tmp66_ = info;
		_tmp67_ = taginfo_info_save (_tmp66_);
		retval = _tmp67_;
	}
	result = retval;
	_taginfo_info_free0 (info);
	_g_free0 (path);
	return result;
}


gboolean xnoise_tag_access_tag_writer_remove_compilation_flag (GFile* file) {
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	gboolean retval = FALSE;
	gchar* path = NULL;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	TagInfo_Info* info = NULL;
	const gchar* _tmp4_ = NULL;
	TagInfo_Info* _tmp5_ = NULL;
	TagInfo_Info* _tmp6_ = NULL;
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
	_tmp0_ = file;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	retval = FALSE;
	path = NULL;
	_tmp1_ = file;
	_tmp2_ = g_file_get_path (_tmp1_);
	_g_free0 (path);
	path = _tmp2_;
	_tmp3_ = path;
	if (_tmp3_ == NULL) {
		result = FALSE;
		_g_free0 (path);
		return result;
	}
	info = NULL;
	_tmp4_ = path;
	_tmp5_ = taginfo_info_create (_tmp4_);
	_taginfo_info_free0 (info);
	info = _tmp5_;
	_tmp6_ = info;
	if (_tmp6_ != NULL) {
		TagInfo_Info* _tmp7_ = NULL;
		TagInfo_Info* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		_tmp7_ = info;
		taginfo_info_set_is_compilation (_tmp7_, FALSE);
		_tmp8_ = info;
		_tmp9_ = taginfo_info_save (_tmp8_);
		retval = _tmp9_;
	}
	result = retval;
	_taginfo_info_free0 (info);
	_g_free0 (path);
	return result;
}


XnoiseTagAccessTagWriter* xnoise_tag_access_tag_writer_construct (GType object_type) {
	XnoiseTagAccessTagWriter* self = NULL;
	self = (XnoiseTagAccessTagWriter*) g_type_create_instance (object_type);
	return self;
}


XnoiseTagAccessTagWriter* xnoise_tag_access_tag_writer_new (void) {
	return xnoise_tag_access_tag_writer_construct (XNOISE_TAG_ACCESS_TYPE_TAG_WRITER);
}


static void xnoise_tag_access_value_tag_writer_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void xnoise_tag_access_value_tag_writer_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		xnoise_tag_access_tag_writer_unref (value->data[0].v_pointer);
	}
}


static void xnoise_tag_access_value_tag_writer_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = xnoise_tag_access_tag_writer_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer xnoise_tag_access_value_tag_writer_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* xnoise_tag_access_value_tag_writer_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		XnoiseTagAccessTagWriter* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = xnoise_tag_access_tag_writer_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* xnoise_tag_access_value_tag_writer_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	XnoiseTagAccessTagWriter** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = xnoise_tag_access_tag_writer_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* xnoise_tag_access_param_spec_tag_writer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	XnoiseTagAccessParamSpecTagWriter* spec;
	g_return_val_if_fail (g_type_is_a (object_type, XNOISE_TAG_ACCESS_TYPE_TAG_WRITER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer xnoise_tag_access_value_get_tag_writer (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_TAG_ACCESS_TYPE_TAG_WRITER), NULL);
	return value->data[0].v_pointer;
}


void xnoise_tag_access_value_set_tag_writer (GValue* value, gpointer v_object) {
	XnoiseTagAccessTagWriter* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_TAG_ACCESS_TYPE_TAG_WRITER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_TAG_ACCESS_TYPE_TAG_WRITER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		xnoise_tag_access_tag_writer_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_tag_access_tag_writer_unref (old);
	}
}


void xnoise_tag_access_value_take_tag_writer (GValue* value, gpointer v_object) {
	XnoiseTagAccessTagWriter* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_TAG_ACCESS_TYPE_TAG_WRITER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_TAG_ACCESS_TYPE_TAG_WRITER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_tag_access_tag_writer_unref (old);
	}
}


static void xnoise_tag_access_tag_writer_class_init (XnoiseTagAccessTagWriterClass * klass) {
	xnoise_tag_access_tag_writer_parent_class = g_type_class_peek_parent (klass);
	XNOISE_TAG_ACCESS_TAG_WRITER_CLASS (klass)->finalize = xnoise_tag_access_tag_writer_finalize;
}


static void xnoise_tag_access_tag_writer_instance_init (XnoiseTagAccessTagWriter * self) {
	self->ref_count = 1;
}


static void xnoise_tag_access_tag_writer_finalize (XnoiseTagAccessTagWriter* obj) {
	XnoiseTagAccessTagWriter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNOISE_TAG_ACCESS_TYPE_TAG_WRITER, XnoiseTagAccessTagWriter);
}


GType xnoise_tag_access_tag_writer_get_type (void) {
	static volatile gsize xnoise_tag_access_tag_writer_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_tag_access_tag_writer_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { xnoise_tag_access_value_tag_writer_init, xnoise_tag_access_value_tag_writer_free_value, xnoise_tag_access_value_tag_writer_copy_value, xnoise_tag_access_value_tag_writer_peek_pointer, "p", xnoise_tag_access_value_tag_writer_collect_value, "p", xnoise_tag_access_value_tag_writer_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (XnoiseTagAccessTagWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_tag_access_tag_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseTagAccessTagWriter), 0, (GInstanceInitFunc) xnoise_tag_access_tag_writer_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType xnoise_tag_access_tag_writer_type_id;
		xnoise_tag_access_tag_writer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "XnoiseTagAccessTagWriter", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&xnoise_tag_access_tag_writer_type_id__volatile, xnoise_tag_access_tag_writer_type_id);
	}
	return xnoise_tag_access_tag_writer_type_id__volatile;
}


gpointer xnoise_tag_access_tag_writer_ref (gpointer instance) {
	XnoiseTagAccessTagWriter* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void xnoise_tag_access_tag_writer_unref (gpointer instance) {
	XnoiseTagAccessTagWriter* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		XNOISE_TAG_ACCESS_TAG_WRITER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



