/* xnoise-mediakeys.c generated by valac, the Vala compiler
 * generated from xnoise-mediakeys.vala, do not modify */

/* xnoise-mediakeys.vala
 *
 * Copyright (C) 2010 - 2011  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 * Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <xnoise-1.0.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gdk/gdkx.h>


#define XNOISE_TYPE_MEDIA_KEYS (xnoise_media_keys_get_type ())
#define XNOISE_MEDIA_KEYS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys))
#define XNOISE_MEDIA_KEYS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeysClass))
#define XNOISE_IS_MEDIA_KEYS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_MEDIA_KEYS))
#define XNOISE_IS_MEDIA_KEYS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_MEDIA_KEYS))
#define XNOISE_MEDIA_KEYS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeysClass))

typedef struct _XnoiseMediaKeys XnoiseMediaKeys;
typedef struct _XnoiseMediaKeysClass XnoiseMediaKeysClass;
typedef struct _XnoiseMediaKeysPrivate XnoiseMediaKeysPrivate;

#define TYPE_GLOBAL_KEY (global_key_get_type ())
#define GLOBAL_KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GLOBAL_KEY, GlobalKey))
#define GLOBAL_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GLOBAL_KEY, GlobalKeyClass))
#define IS_GLOBAL_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GLOBAL_KEY))
#define IS_GLOBAL_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GLOBAL_KEY))
#define GLOBAL_KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GLOBAL_KEY, GlobalKeyClass))

typedef struct _GlobalKey GlobalKey;
typedef struct _GlobalKeyClass GlobalKeyClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GlobalKeyPrivate GlobalKeyPrivate;

struct _XnoiseMediaKeys {
	GObject parent_instance;
	XnoiseMediaKeysPrivate * priv;
};

struct _XnoiseMediaKeysClass {
	GObjectClass parent_class;
};

struct _XnoiseMediaKeysPrivate {
	XnoisePluginModuleContainer* _owner;
	XnoiseMain* _xn;
	GlobalKey* stopkey;
	GlobalKey* prevkey;
	GlobalKey* playkey;
	GlobalKey* nextkey;
	XnoiseGnomeMediaKeys* gmk;
	guint watch;
};

struct _GlobalKey {
	GObject parent_instance;
	GlobalKeyPrivate * priv;
};

struct _GlobalKeyClass {
	GObjectClass parent_class;
};

struct _GlobalKeyPrivate {
	gboolean _registered;
	gint keysym;
	gint keycode;
	guint modifiers;
	GdkWindow* root_window;
	Display* xdisplay;
};


static gpointer xnoise_media_keys_parent_class = NULL;
static XnoisePluginModuleIPluginIface* xnoise_media_keys_xnoise_plugin_module_iplugin_parent_iface = NULL;
static GType xnoise_media_keys_type_id = 0;
static gpointer global_key_parent_class = NULL;
static GType global_key_type_id = 0;

GType xnoise_media_keys_get_type (void) G_GNUC_CONST;
GType xnoise_media_keys_register_type (GTypeModule * module);
GType global_key_get_type (void) G_GNUC_CONST;
GType global_key_register_type (GTypeModule * module);
#define XNOISE_MEDIA_KEYS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeysPrivate))
enum  {
	XNOISE_MEDIA_KEYS_DUMMY_PROPERTY,
	XNOISE_MEDIA_KEYS_XN,
	XNOISE_MEDIA_KEYS_OWNER,
	XNOISE_MEDIA_KEYS_NAME
};
#define XNOISE_MEDIA_KEYS_AnyModifier ((guint) (1 << 15))
static void xnoise_media_keys_on_name_appeared (XnoiseMediaKeys* self, GDBusConnection* conn, const gchar* name);
void global_key_unregister (GlobalKey* self);
static gboolean xnoise_media_keys_setup_x_keys (XnoiseMediaKeys* self);
static gboolean _____lambda6_ (XnoiseMediaKeys* self);
static gboolean ______lambda6__gsource_func (gpointer self);
static void xnoise_media_keys_on_media_player_key_pressed (XnoiseMediaKeys* self, const gchar* application, const gchar* key);
static void _xnoise_media_keys_on_media_player_key_pressed_xnoise_gnome_media_keys_media_player_key_pressed (XnoiseGnomeMediaKeys* _sender, const gchar* application, const gchar* key, gpointer self);
static gboolean _____lambda7_ (XnoiseMediaKeys* self);
static gboolean ______lambda7__gsource_func (gpointer self);
static void xnoise_media_keys_on_name_vanished (XnoiseMediaKeys* self, GDBusConnection* conn, const gchar* name);
static gboolean ____lambda8_ (XnoiseMediaKeys* self);
static gboolean _____lambda8__gsource_func (gpointer self);
static void xnoise_media_keys_get_keys_dbus (XnoiseMediaKeys* self);
static void _xnoise_media_keys_on_name_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self);
static void _xnoise_media_keys_on_name_vanished_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self);
GlobalKey* global_key_new (gint _keysym, guint _modifiers);
GlobalKey* global_key_construct (GType object_type, gint _keysym, guint _modifiers);
gboolean global_key_register (GlobalKey* self);
static void ____lambda2_ (XnoiseMediaKeys* self);
static void _____lambda2__global_key_pressed (GlobalKey* _sender, gpointer self);
static void ____lambda3_ (XnoiseMediaKeys* self);
static void _____lambda3__global_key_pressed (GlobalKey* _sender, gpointer self);
static void ____lambda4_ (XnoiseMediaKeys* self);
static void _____lambda4__global_key_pressed (GlobalKey* _sender, gpointer self);
static void ____lambda5_ (XnoiseMediaKeys* self);
static void _____lambda5__global_key_pressed (GlobalKey* _sender, gpointer self);
static gboolean xnoise_media_keys_real_init (XnoisePluginModuleIPlugin* base);
static gboolean __lambda9_ (XnoiseMediaKeys* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static void xnoise_media_keys_real_uninit (XnoisePluginModuleIPlugin* base);
static GtkWidget* xnoise_media_keys_real_get_settings_widget (XnoisePluginModuleIPlugin* base);
static gboolean xnoise_media_keys_real_has_settings_widget (XnoisePluginModuleIPlugin* base);
XnoiseMediaKeys* xnoise_media_keys_new (void);
XnoiseMediaKeys* xnoise_media_keys_construct (GType object_type);
static void xnoise_media_keys_finalize (GObject* obj);
static void _vala_xnoise_media_keys_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_xnoise_media_keys_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define GLOBAL_KEY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_GLOBAL_KEY, GlobalKeyPrivate))
enum  {
	GLOBAL_KEY_DUMMY_PROPERTY,
	GLOBAL_KEY_REGISTERED
};
#define GLOBAL_KEY_GRAB_ASYNC 1
#define GLOBAL_KEY_KEY_PRESSED 2
static Display* global_key_get_x_display_for_window (GdkWindow* window);
static GdkFilterReturn global_key_filterfunc (GdkXEvent* e1, GdkEvent* e2, GlobalKey* self);
static GdkFilterReturn _global_key_filterfunc_gdk_filter_func (GdkXEvent* xevent, GdkEvent* event, gpointer self);
static XID global_key_get_x_id_for_window (GdkWindow* window);
gboolean global_key_get_registered (GlobalKey* self);
static void global_key_finalize (GObject* obj);
static void _vala_global_key_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


static gboolean _____lambda6_ (XnoiseMediaKeys* self) {
	gboolean result = FALSE;
	XnoisePluginModuleContainer* _tmp0_ = NULL;
	XnoisePluginModuleContainer* _tmp1_ = NULL;
	_tmp0_ = xnoise_plugin_module_iplugin_get_owner (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin));
	_tmp1_ = _tmp0_;
	xnoise_plugin_module_container_deactivate (_tmp1_);
	result = FALSE;
	return result;
}


static gboolean ______lambda6__gsource_func (gpointer self) {
	gboolean result;
	result = _____lambda6_ (self);
	return result;
}


static void _xnoise_media_keys_on_media_player_key_pressed_xnoise_gnome_media_keys_media_player_key_pressed (XnoiseGnomeMediaKeys* _sender, const gchar* application, const gchar* key, gpointer self) {
	xnoise_media_keys_on_media_player_key_pressed (self, application, key);
}


static gboolean _____lambda7_ (XnoiseMediaKeys* self) {
	gboolean result = FALSE;
	XnoisePluginModuleContainer* _tmp0_ = NULL;
	XnoisePluginModuleContainer* _tmp1_ = NULL;
	_tmp0_ = xnoise_plugin_module_iplugin_get_owner (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin));
	_tmp1_ = _tmp0_;
	xnoise_plugin_module_container_deactivate (_tmp1_);
	result = FALSE;
	return result;
}


static gboolean ______lambda7__gsource_func (gpointer self) {
	gboolean result;
	result = _____lambda7_ (self);
	return result;
}


static void xnoise_media_keys_on_name_appeared (XnoiseMediaKeys* self, GDBusConnection* conn, const gchar* name) {
	GlobalKey* _tmp0_ = NULL;
	GlobalKey* _tmp2_ = NULL;
	GlobalKey* _tmp4_ = NULL;
	GlobalKey* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (XNOISE_IS_MEDIA_KEYS (self));
	g_return_if_fail (G_IS_DBUS_CONNECTION (conn));
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->stopkey;
	if (_tmp0_ != NULL) {
		GlobalKey* _tmp1_ = NULL;
		_tmp1_ = self->priv->stopkey;
		global_key_unregister (_tmp1_);
	}
	_tmp2_ = self->priv->prevkey;
	if (_tmp2_ != NULL) {
		GlobalKey* _tmp3_ = NULL;
		_tmp3_ = self->priv->prevkey;
		global_key_unregister (_tmp3_);
	}
	_tmp4_ = self->priv->playkey;
	if (_tmp4_ != NULL) {
		GlobalKey* _tmp5_ = NULL;
		_tmp5_ = self->priv->playkey;
		global_key_unregister (_tmp5_);
	}
	_tmp6_ = self->priv->nextkey;
	if (_tmp6_ != NULL) {
		GlobalKey* _tmp7_ = NULL;
		_tmp7_ = self->priv->nextkey;
		global_key_unregister (_tmp7_);
	}
	{
		XnoiseGnomeMediaKeys* _tmp8_ = NULL;
		XnoiseGnomeMediaKeys* _tmp9_ = NULL;
		_tmp9_ = g_initable_new (XNOISE_TYPE_GNOME_MEDIA_KEYS_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", "org.gnome.SettingsDaemon", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SettingsDaemon/MediaKeys", "g-interface-name", "org.gnome.SettingsDaemon.MediaKeys", NULL);
		_tmp8_ = (XnoiseGnomeMediaKeys*) _tmp9_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_object_unref0 (self->priv->gmk);
		self->priv->gmk = _tmp8_;
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		g_print ("Mediakeys error: %s", _tmp11_);
		g_print ("Mediakeys: Using x keybindings instead of gnome-settings-daemon's dbus" \
" service'\n");
		_g_object_unref0 (self->priv->gmk);
		self->priv->gmk = NULL;
		_tmp12_ = xnoise_media_keys_setup_x_keys (self);
		if (!_tmp12_) {
			XnoisePluginModuleContainer* _tmp13_ = NULL;
			XnoisePluginModuleContainer* _tmp14_ = NULL;
			_tmp13_ = xnoise_plugin_module_iplugin_get_owner (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin));
			_tmp14_ = _tmp13_;
			if (_tmp14_ != NULL) {
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ______lambda6__gsource_func, g_object_ref (self), g_object_unref);
			}
		}
		_g_error_free0 (e);
		return;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		XnoiseGnomeMediaKeys* _tmp15_ = NULL;
		XnoiseGnomeMediaKeys* _tmp16_ = NULL;
		_tmp15_ = self->priv->gmk;
		xnoise_gnome_media_keys_GrabMediaPlayerKeys (_tmp15_, "xnoise", (guint32) 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_tmp16_ = self->priv->gmk;
		g_signal_connect_object (_tmp16_, "media-player-key-pressed", (GCallback) _xnoise_media_keys_on_media_player_key_pressed_xnoise_gnome_media_keys_media_player_key_pressed, self, 0);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		gboolean _tmp17_ = FALSE;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_print ("Mediakeys: Using x keybindings instead of gnome-settings-daemon's dbus" \
" service'\n");
		_g_object_unref0 (self->priv->gmk);
		self->priv->gmk = NULL;
		_tmp17_ = xnoise_media_keys_setup_x_keys (self);
		if (!_tmp17_) {
			XnoisePluginModuleContainer* _tmp18_ = NULL;
			XnoisePluginModuleContainer* _tmp19_ = NULL;
			_tmp18_ = xnoise_plugin_module_iplugin_get_owner (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin));
			_tmp19_ = _tmp18_;
			if (_tmp19_ != NULL) {
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ______lambda7__gsource_func, g_object_ref (self), g_object_unref);
			}
		}
		_g_error_free0 (e);
		return;
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static gboolean ____lambda8_ (XnoiseMediaKeys* self) {
	gboolean result = FALSE;
	XnoisePluginModuleContainer* _tmp0_ = NULL;
	XnoisePluginModuleContainer* _tmp1_ = NULL;
	_tmp0_ = xnoise_plugin_module_iplugin_get_owner (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin));
	_tmp1_ = _tmp0_;
	xnoise_plugin_module_container_deactivate (_tmp1_);
	result = FALSE;
	return result;
}


static gboolean _____lambda8__gsource_func (gpointer self) {
	gboolean result;
	result = ____lambda8_ (self);
	return result;
}


static void xnoise_media_keys_on_name_vanished (XnoiseMediaKeys* self, GDBusConnection* conn, const gchar* name) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (XNOISE_IS_MEDIA_KEYS (self));
	g_return_if_fail (G_IS_DBUS_CONNECTION (conn));
	g_return_if_fail (name != NULL);
	_tmp0_ = xnoise_media_keys_setup_x_keys (self);
	if (!_tmp0_) {
		XnoisePluginModuleContainer* _tmp1_ = NULL;
		XnoisePluginModuleContainer* _tmp2_ = NULL;
		_tmp1_ = xnoise_plugin_module_iplugin_get_owner (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin));
		_tmp2_ = _tmp1_;
		if (_tmp2_ != NULL) {
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda8__gsource_func, g_object_ref (self), g_object_unref);
		}
	}
	return;
}


static void _xnoise_media_keys_on_name_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self) {
	xnoise_media_keys_on_name_appeared (self, connection, name);
}


static void _xnoise_media_keys_on_name_vanished_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	xnoise_media_keys_on_name_vanished (self, connection, name);
}


static void xnoise_media_keys_get_keys_dbus (XnoiseMediaKeys* self) {
	guint _tmp0_ = 0U;
	g_return_if_fail (XNOISE_IS_MEDIA_KEYS (self));
	_tmp0_ = g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, "org.gnome.SettingsDaemon", G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((_xnoise_media_keys_on_name_appeared_gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_media_keys_on_name_appeared_gbus_name_appeared_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((_xnoise_media_keys_on_name_vanished_gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _xnoise_media_keys_on_name_vanished_gbus_name_vanished_callback, g_object_ref (self), g_object_unref)));
	self->priv->watch = _tmp0_;
}


static void ____lambda2_ (XnoiseMediaKeys* self) {
	XnoiseGlobalAccess* _tmp0_ = NULL;
	_tmp0_ = xnoise_global;
	xnoise_global_access_stop (_tmp0_);
}


static void _____lambda2__global_key_pressed (GlobalKey* _sender, gpointer self) {
	____lambda2_ (self);
}


static void ____lambda3_ (XnoiseMediaKeys* self) {
	XnoiseGlobalAccess* _tmp0_ = NULL;
	_tmp0_ = xnoise_global;
	xnoise_global_access_prev (_tmp0_);
}


static void _____lambda3__global_key_pressed (GlobalKey* _sender, gpointer self) {
	____lambda3_ (self);
}


static void ____lambda4_ (XnoiseMediaKeys* self) {
	XnoiseGlobalAccess* _tmp0_ = NULL;
	_tmp0_ = xnoise_global;
	xnoise_global_access_play (_tmp0_, TRUE);
}


static void _____lambda4__global_key_pressed (GlobalKey* _sender, gpointer self) {
	____lambda4_ (self);
}


static void ____lambda5_ (XnoiseMediaKeys* self) {
	XnoiseGlobalAccess* _tmp0_ = NULL;
	_tmp0_ = xnoise_global;
	xnoise_global_access_next (_tmp0_);
}


static void _____lambda5__global_key_pressed (GlobalKey* _sender, gpointer self) {
	____lambda5_ (self);
}


static gboolean xnoise_media_keys_setup_x_keys (XnoiseMediaKeys* self) {
	gboolean result = FALSE;
	XnoiseGnomeMediaKeys* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (XNOISE_IS_MEDIA_KEYS (self), FALSE);
	_tmp0_ = self->priv->gmk;
	if (_tmp0_ != NULL) {
		XnoiseGnomeMediaKeys* _tmp1_ = NULL;
		_tmp1_ = self->priv->gmk;
		g_signal_connect_object (_tmp1_, "media-player-key-pressed", (GCallback) _xnoise_media_keys_on_media_player_key_pressed_xnoise_gnome_media_keys_media_player_key_pressed, self, 0);
		{
			XnoiseGnomeMediaKeys* _tmp2_ = NULL;
			_tmp2_ = self->priv->gmk;
			xnoise_gnome_media_keys_GrabMediaPlayerKeys (_tmp2_, "xnoise", (guint32) 0, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp3_ = NULL;
			const gchar* _tmp4_ = NULL;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			_tmp3_ = _error_;
			_tmp4_ = _tmp3_->message;
			g_print ("%s", _tmp4_);
			_g_error_free0 (_error_);
		}
		__finally2:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	} else {
		guint _tmp5_ = 0U;
		GlobalKey* _tmp6_ = NULL;
		GlobalKey* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		guint _tmp10_ = 0U;
		GlobalKey* _tmp11_ = NULL;
		GlobalKey* _tmp12_ = NULL;
		gboolean _tmp13_ = FALSE;
		guint _tmp15_ = 0U;
		GlobalKey* _tmp16_ = NULL;
		GlobalKey* _tmp17_ = NULL;
		gboolean _tmp18_ = FALSE;
		guint _tmp20_ = 0U;
		GlobalKey* _tmp21_ = NULL;
		GlobalKey* _tmp22_ = NULL;
		gboolean _tmp23_ = FALSE;
		_tmp5_ = gdk_keyval_from_name ("XF86AudioStop");
		_tmp6_ = global_key_new ((gint) _tmp5_, XNOISE_MEDIA_KEYS_AnyModifier);
		_g_object_unref0 (self->priv->stopkey);
		self->priv->stopkey = _tmp6_;
		_tmp7_ = self->priv->stopkey;
		_tmp8_ = global_key_register (_tmp7_);
		if (_tmp8_) {
			GlobalKey* _tmp9_ = NULL;
			_tmp9_ = self->priv->stopkey;
			g_signal_connect_object (_tmp9_, "pressed", (GCallback) _____lambda2__global_key_pressed, self, 0);
		} else {
			result = FALSE;
			return result;
		}
		_tmp10_ = gdk_keyval_from_name ("XF86AudioPrev");
		_tmp11_ = global_key_new ((gint) _tmp10_, XNOISE_MEDIA_KEYS_AnyModifier);
		_g_object_unref0 (self->priv->prevkey);
		self->priv->prevkey = _tmp11_;
		_tmp12_ = self->priv->prevkey;
		_tmp13_ = global_key_register (_tmp12_);
		if (_tmp13_) {
			GlobalKey* _tmp14_ = NULL;
			_tmp14_ = self->priv->prevkey;
			g_signal_connect_object (_tmp14_, "pressed", (GCallback) _____lambda3__global_key_pressed, self, 0);
		} else {
			result = FALSE;
			return result;
		}
		_tmp15_ = gdk_keyval_from_name ("XF86AudioPlay");
		_tmp16_ = global_key_new ((gint) _tmp15_, XNOISE_MEDIA_KEYS_AnyModifier);
		_g_object_unref0 (self->priv->playkey);
		self->priv->playkey = _tmp16_;
		_tmp17_ = self->priv->playkey;
		_tmp18_ = global_key_register (_tmp17_);
		if (_tmp18_) {
			GlobalKey* _tmp19_ = NULL;
			_tmp19_ = self->priv->playkey;
			g_signal_connect_object (_tmp19_, "pressed", (GCallback) _____lambda4__global_key_pressed, self, 0);
		} else {
			result = FALSE;
			return result;
		}
		_tmp20_ = gdk_keyval_from_name ("XF86AudioNext");
		_tmp21_ = global_key_new ((gint) _tmp20_, XNOISE_MEDIA_KEYS_AnyModifier);
		_g_object_unref0 (self->priv->nextkey);
		self->priv->nextkey = _tmp21_;
		_tmp22_ = self->priv->nextkey;
		_tmp23_ = global_key_register (_tmp22_);
		if (_tmp23_) {
			GlobalKey* _tmp24_ = NULL;
			_tmp24_ = self->priv->nextkey;
			g_signal_connect_object (_tmp24_, "pressed", (GCallback) _____lambda5__global_key_pressed, self, 0);
		} else {
			result = FALSE;
			return result;
		}
	}
	result = TRUE;
	return result;
}


static gboolean __lambda9_ (XnoiseMediaKeys* self) {
	gboolean result = FALSE;
	xnoise_media_keys_get_keys_dbus (self);
	result = FALSE;
	return result;
}


static gboolean ___lambda9__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda9_ (self);
	return result;
}


static gboolean xnoise_media_keys_real_init (XnoisePluginModuleIPlugin* base) {
	XnoiseMediaKeys * self;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, g_object_ref (self), g_object_unref);
	result = TRUE;
	return result;
}


static void xnoise_media_keys_real_uninit (XnoisePluginModuleIPlugin* base) {
	XnoiseMediaKeys * self;
	GlobalKey* _tmp0_ = NULL;
	GlobalKey* _tmp2_ = NULL;
	GlobalKey* _tmp4_ = NULL;
	GlobalKey* _tmp6_ = NULL;
	guint _tmp12_ = 0U;
	GError * _inner_error_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	_tmp0_ = self->priv->stopkey;
	if (_tmp0_ != NULL) {
		GlobalKey* _tmp1_ = NULL;
		_tmp1_ = self->priv->stopkey;
		global_key_unregister (_tmp1_);
	}
	_tmp2_ = self->priv->prevkey;
	if (_tmp2_ != NULL) {
		GlobalKey* _tmp3_ = NULL;
		_tmp3_ = self->priv->prevkey;
		global_key_unregister (_tmp3_);
	}
	_tmp4_ = self->priv->playkey;
	if (_tmp4_ != NULL) {
		GlobalKey* _tmp5_ = NULL;
		_tmp5_ = self->priv->playkey;
		global_key_unregister (_tmp5_);
	}
	_tmp6_ = self->priv->nextkey;
	if (_tmp6_ != NULL) {
		GlobalKey* _tmp7_ = NULL;
		_tmp7_ = self->priv->nextkey;
		global_key_unregister (_tmp7_);
	}
	{
		XnoiseGnomeMediaKeys* _tmp8_ = NULL;
		_tmp8_ = self->priv->gmk;
		if (_tmp8_ != NULL) {
			XnoiseGnomeMediaKeys* _tmp9_ = NULL;
			_tmp9_ = self->priv->gmk;
			xnoise_gnome_media_keys_ReleaseMediaPlayerKeys (_tmp9_, "xnoise", &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch3_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	goto __finally3;
	__catch3_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		g_print ("%s", _tmp11_);
		_g_error_free0 (e);
	}
	__finally3:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp12_ = self->priv->watch;
	if (_tmp12_ != ((guint) 0)) {
		guint _tmp13_ = 0U;
		_tmp13_ = self->priv->watch;
		g_bus_unwatch_name (_tmp13_);
		self->priv->watch = (guint) 0;
	}
}


static GtkWidget* xnoise_media_keys_real_get_settings_widget (XnoisePluginModuleIPlugin* base) {
	XnoiseMediaKeys * self;
	GtkWidget* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	result = NULL;
	return result;
}


static gboolean xnoise_media_keys_real_has_settings_widget (XnoisePluginModuleIPlugin* base) {
	XnoiseMediaKeys * self;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	result = FALSE;
	return result;
}


static void xnoise_media_keys_on_media_player_key_pressed (XnoiseMediaKeys* self, const gchar* application, const gchar* key) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GQuark _tmp4_ = 0U;
	static GQuark _tmp3_label0 = 0;
	static GQuark _tmp3_label1 = 0;
	static GQuark _tmp3_label2 = 0;
	static GQuark _tmp3_label3 = 0;
	g_return_if_fail (XNOISE_IS_MEDIA_KEYS (self));
	g_return_if_fail (application != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = application;
	if (g_strcmp0 (_tmp0_, "xnoise") != 0) {
		return;
	}
	_tmp1_ = key;
	_tmp2_ = _tmp1_;
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("Next")))) {
		switch (0) {
			default:
			{
				{
					XnoiseGlobalAccess* _tmp5_ = NULL;
					_tmp5_ = xnoise_global;
					xnoise_global_access_next (_tmp5_);
					break;
				}
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("Previous")))) {
		switch (0) {
			default:
			{
				{
					XnoiseGlobalAccess* _tmp6_ = NULL;
					_tmp6_ = xnoise_global;
					xnoise_global_access_prev (_tmp6_);
					break;
				}
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("Play")))) {
		switch (0) {
			default:
			{
				{
					XnoiseGlobalAccess* _tmp7_ = NULL;
					_tmp7_ = xnoise_global;
					xnoise_global_access_play (_tmp7_, TRUE);
					break;
				}
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("Stop")))) {
		switch (0) {
			default:
			{
				{
					XnoiseGlobalAccess* _tmp8_ = NULL;
					_tmp8_ = xnoise_global;
					xnoise_global_access_stop (_tmp8_);
					break;
				}
			}
		}
	} else {
		switch (0) {
			default:
			{
				break;
			}
		}
	}
}


XnoiseMediaKeys* xnoise_media_keys_construct (GType object_type) {
	XnoiseMediaKeys * self = NULL;
	self = (XnoiseMediaKeys*) g_object_new (object_type, NULL);
	return self;
}


XnoiseMediaKeys* xnoise_media_keys_new (void) {
	return xnoise_media_keys_construct (XNOISE_TYPE_MEDIA_KEYS);
}


static XnoiseMain* xnoise_media_keys_real_get_xn (XnoisePluginModuleIPlugin* base) {
	XnoiseMain* result;
	XnoiseMediaKeys* self;
	XnoiseMain* _tmp0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	_tmp0_ = self->priv->_xn;
	result = _tmp0_;
	return result;
}


static void xnoise_media_keys_real_set_xn (XnoisePluginModuleIPlugin* base, XnoiseMain* value) {
	XnoiseMediaKeys* self;
	XnoiseMain* _tmp0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	_tmp0_ = value;
	self->priv->_xn = _tmp0_;
	g_object_notify ((GObject *) self, "xn");
}


static XnoisePluginModuleContainer* xnoise_media_keys_real_get_owner (XnoisePluginModuleIPlugin* base) {
	XnoisePluginModuleContainer* result;
	XnoiseMediaKeys* self;
	XnoisePluginModuleContainer* _tmp0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	_tmp0_ = self->priv->_owner;
	result = _tmp0_;
	return result;
}


static void xnoise_media_keys_real_set_owner (XnoisePluginModuleIPlugin* base, XnoisePluginModuleContainer* value) {
	XnoiseMediaKeys* self;
	XnoisePluginModuleContainer* _tmp0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	_tmp0_ = value;
	self->priv->_owner = _tmp0_;
	g_object_notify ((GObject *) self, "owner");
}


static const gchar* xnoise_media_keys_real_get_name (XnoisePluginModuleIPlugin* base) {
	const gchar* result;
	XnoiseMediaKeys* self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	result = "mediakeys";
	return result;
}


static void xnoise_media_keys_class_init (XnoiseMediaKeysClass * klass) {
	xnoise_media_keys_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseMediaKeysPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_xnoise_media_keys_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_xnoise_media_keys_set_property;
	G_OBJECT_CLASS (klass)->finalize = xnoise_media_keys_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_MEDIA_KEYS_XN, g_param_spec_object ("xn", "xn", "xn", XNOISE_TYPE_MAIN, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_MEDIA_KEYS_OWNER, g_param_spec_object ("owner", "owner", "owner", XNOISE_PLUGIN_MODULE_TYPE_CONTAINER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), XNOISE_MEDIA_KEYS_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void xnoise_media_keys_xnoise_plugin_module_iplugin_interface_init (XnoisePluginModuleIPluginIface * iface) {
	xnoise_media_keys_xnoise_plugin_module_iplugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->init = (gboolean (*)(XnoisePluginModuleIPlugin*)) xnoise_media_keys_real_init;
	iface->uninit = (void (*)(XnoisePluginModuleIPlugin*)) xnoise_media_keys_real_uninit;
	iface->get_settings_widget = (GtkWidget* (*)(XnoisePluginModuleIPlugin*)) xnoise_media_keys_real_get_settings_widget;
	iface->has_settings_widget = (gboolean (*)(XnoisePluginModuleIPlugin*)) xnoise_media_keys_real_has_settings_widget;
	iface->get_xn = xnoise_media_keys_real_get_xn;
	iface->set_xn = xnoise_media_keys_real_set_xn;
	iface->get_owner = xnoise_media_keys_real_get_owner;
	iface->set_owner = xnoise_media_keys_real_set_owner;
	iface->get_name = xnoise_media_keys_real_get_name;
}


static void xnoise_media_keys_instance_init (XnoiseMediaKeys * self) {
	self->priv = XNOISE_MEDIA_KEYS_GET_PRIVATE (self);
	self->priv->stopkey = NULL;
	self->priv->prevkey = NULL;
	self->priv->playkey = NULL;
	self->priv->nextkey = NULL;
	self->priv->gmk = NULL;
}


static void xnoise_media_keys_finalize (GObject* obj) {
	XnoiseMediaKeys * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	_g_object_unref0 (self->priv->stopkey);
	_g_object_unref0 (self->priv->prevkey);
	_g_object_unref0 (self->priv->playkey);
	_g_object_unref0 (self->priv->nextkey);
	_g_object_unref0 (self->priv->gmk);
	G_OBJECT_CLASS (xnoise_media_keys_parent_class)->finalize (obj);
}


GType xnoise_media_keys_get_type (void) {
	return xnoise_media_keys_type_id;
}


GType xnoise_media_keys_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseMediaKeysClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_media_keys_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseMediaKeys), 0, (GInstanceInitFunc) xnoise_media_keys_instance_init, NULL };
	static const GInterfaceInfo xnoise_plugin_module_iplugin_info = { (GInterfaceInitFunc) xnoise_media_keys_xnoise_plugin_module_iplugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	xnoise_media_keys_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseMediaKeys", &g_define_type_info, 0);
	g_type_module_add_interface (module, xnoise_media_keys_type_id, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, &xnoise_plugin_module_iplugin_info);
	return xnoise_media_keys_type_id;
}


static void _vala_xnoise_media_keys_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	XnoiseMediaKeys * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	switch (property_id) {
		case XNOISE_MEDIA_KEYS_XN:
		g_value_set_object (value, xnoise_plugin_module_iplugin_get_xn (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin)));
		break;
		case XNOISE_MEDIA_KEYS_OWNER:
		g_value_set_object (value, xnoise_plugin_module_iplugin_get_owner (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin)));
		break;
		case XNOISE_MEDIA_KEYS_NAME:
		g_value_set_string (value, xnoise_plugin_module_iplugin_get_name (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin)));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_xnoise_media_keys_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	XnoiseMediaKeys * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, XNOISE_TYPE_MEDIA_KEYS, XnoiseMediaKeys);
	switch (property_id) {
		case XNOISE_MEDIA_KEYS_XN:
		xnoise_plugin_module_iplugin_set_xn (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin), g_value_get_object (value));
		break;
		case XNOISE_MEDIA_KEYS_OWNER:
		xnoise_plugin_module_iplugin_set_owner (G_TYPE_CHECK_INSTANCE_CAST (self, XNOISE_PLUGIN_MODULE_TYPE_IPLUGIN, XnoisePluginModuleIPlugin), g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


GlobalKey* global_key_construct (GType object_type, gint _keysym, guint _modifiers) {
	GlobalKey * self = NULL;
	gint _tmp0_ = 0;
	guint _tmp1_ = 0U;
	GdkWindow* _tmp2_ = NULL;
	GdkWindow* _tmp3_ = NULL;
	Display* _tmp4_ = NULL;
	Display* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	guchar _tmp7_ = '\0';
	self = (GlobalKey*) g_object_new (object_type, NULL);
	_tmp0_ = _keysym;
	self->priv->keysym = _tmp0_;
	_tmp1_ = _modifiers;
	self->priv->modifiers = _tmp1_;
	_tmp2_ = gdk_get_default_root_window ();
	self->priv->root_window = _tmp2_;
	_tmp3_ = self->priv->root_window;
	_tmp4_ = global_key_get_x_display_for_window (_tmp3_);
	self->priv->xdisplay = _tmp4_;
	_tmp5_ = self->priv->xdisplay;
	_tmp6_ = self->priv->keysym;
	_tmp7_ = XKeysymToKeycode (_tmp5_, (gulong) _tmp6_);
	self->priv->keycode = (gint) _tmp7_;
	return self;
}


GlobalKey* global_key_new (gint _keysym, guint _modifiers) {
	return global_key_construct (TYPE_GLOBAL_KEY, _keysym, _modifiers);
}


static GdkFilterReturn global_key_filterfunc (GdkXEvent* e1, GdkEvent* e2, GlobalKey* self) {
	GdkFilterReturn result = 0;
	XEvent* e0 = NULL;
	GdkXEvent* _tmp0_ = NULL;
	XEvent* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	XEvent* _tmp3_ = NULL;
	XKeyEvent _tmp4_ = {0};
	gint _tmp5_ = 0;
	gboolean _tmp10_ = FALSE;
	g_return_val_if_fail (IS_GLOBAL_KEY (self), 0);
	g_return_val_if_fail (e1 != NULL, 0);
	g_return_val_if_fail (e2 != NULL, 0);
	_tmp0_ = e1;
	e0 = (XEvent*) _tmp0_;
	_tmp1_ = e0;
	if (_tmp1_ == NULL) {
		g_print ("event error mediakeys\n");
		result = GDK_FILTER_CONTINUE;
		return result;
	}
	_tmp3_ = e0;
	_tmp4_ = (*_tmp3_).xkey;
	_tmp5_ = _tmp4_.type;
	if (_tmp5_ == GLOBAL_KEY_KEY_PRESSED) {
		gint _tmp6_ = 0;
		XEvent* _tmp7_ = NULL;
		XKeyEvent _tmp8_ = {0};
		guint _tmp9_ = 0U;
		_tmp6_ = self->priv->keycode;
		_tmp7_ = e0;
		_tmp8_ = (*_tmp7_).xkey;
		_tmp9_ = _tmp8_.keycode;
		_tmp2_ = ((guint) _tmp6_) == _tmp9_;
	} else {
		_tmp2_ = FALSE;
	}
	_tmp10_ = _tmp2_;
	if (_tmp10_) {
		g_signal_emit_by_name (self, "pressed");
		result = GDK_FILTER_REMOVE;
		return result;
	}
	result = GDK_FILTER_CONTINUE;
	return result;
}


static GdkFilterReturn _global_key_filterfunc_gdk_filter_func (GdkXEvent* xevent, GdkEvent* event, gpointer self) {
	GdkFilterReturn result;
	result = global_key_filterfunc (xevent, event, self);
	return result;
}


gboolean global_key_register (GlobalKey* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Display* _tmp1_ = NULL;
	gboolean _tmp3_ = FALSE;
	GdkWindow* _tmp4_ = NULL;
	Display* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	guint _tmp7_ = 0U;
	GdkWindow* _tmp8_ = NULL;
	XID _tmp9_ = 0;
	gint _tmp10_ = 0;
	g_return_val_if_fail (IS_GLOBAL_KEY (self), FALSE);
	_tmp1_ = self->priv->xdisplay;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp2_ = 0;
		_tmp2_ = self->priv->keycode;
		_tmp0_ = _tmp2_ == 0;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		result = FALSE;
		return result;
	}
	_tmp4_ = self->priv->root_window;
	gdk_window_add_filter (_tmp4_, _global_key_filterfunc_gdk_filter_func, self);
	gdk_error_trap_push ();
	_tmp5_ = self->priv->xdisplay;
	_tmp6_ = self->priv->keycode;
	_tmp7_ = self->priv->modifiers;
	_tmp8_ = self->priv->root_window;
	_tmp9_ = global_key_get_x_id_for_window (_tmp8_);
	XGrabKey (_tmp5_, _tmp6_, _tmp7_, (Window) _tmp9_, FALSE, GLOBAL_KEY_GRAB_ASYNC, GLOBAL_KEY_GRAB_ASYNC);
	gdk_flush ();
	_tmp10_ = gdk_error_trap_pop ();
	if (_tmp10_ != 0) {
		gint _tmp11_ = 0;
		self->priv->_registered = FALSE;
		_tmp11_ = self->priv->keycode;
		g_print ("failed to grab key %d\n", _tmp11_);
		result = FALSE;
		return result;
	}
	self->priv->_registered = TRUE;
	result = TRUE;
	return result;
}


void global_key_unregister (GlobalKey* self) {
	gboolean _tmp0_ = FALSE;
	Display* _tmp1_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GdkWindow* _tmp5_ = NULL;
	Display* _tmp6_ = NULL;
	Display* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	guint _tmp9_ = 0U;
	GdkWindow* _tmp10_ = NULL;
	XID _tmp11_ = 0;
	g_return_if_fail (IS_GLOBAL_KEY (self));
	_tmp1_ = self->priv->xdisplay;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp2_ = 0;
		_tmp2_ = self->priv->keycode;
		_tmp0_ = _tmp2_ == 0;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		return;
	}
	_tmp4_ = self->priv->_registered;
	if (!_tmp4_) {
		return;
	}
	_tmp5_ = self->priv->root_window;
	gdk_window_remove_filter (_tmp5_, _global_key_filterfunc_gdk_filter_func, self);
	_tmp6_ = self->priv->xdisplay;
	if (_tmp6_ == NULL) {
		return;
	}
	_tmp7_ = self->priv->xdisplay;
	_tmp8_ = self->priv->keycode;
	_tmp9_ = self->priv->modifiers;
	_tmp10_ = self->priv->root_window;
	_tmp11_ = global_key_get_x_id_for_window (_tmp10_);
	XUngrabKey (_tmp7_, _tmp8_, _tmp9_, (Window) _tmp11_);
	self->priv->_registered = FALSE;
}


static XID global_key_get_x_id_for_window (GdkWindow* window) {
	XID result = 0;
	GdkWindow* _tmp0_ = NULL;
	Window _tmp1_ = 0;
	g_return_val_if_fail (GDK_IS_WINDOW (window), 0);
	_tmp0_ = window;
	_tmp1_ = gdk_x11_window_get_xid (_tmp0_);
	result = (XID) _tmp1_;
	return result;
}


static Display* global_key_get_x_display_for_window (GdkWindow* window) {
	Display* result = NULL;
	GdkWindow* _tmp0_ = NULL;
	GdkDisplay* _tmp1_ = NULL;
	Display* _tmp2_ = NULL;
	g_return_val_if_fail (GDK_IS_WINDOW (window), NULL);
	_tmp0_ = window;
	_tmp1_ = gdk_window_get_display (_tmp0_);
	_tmp2_ = gdk_x11_display_get_xdisplay (_tmp1_);
	result = _tmp2_;
	return result;
}


gboolean global_key_get_registered (GlobalKey* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (IS_GLOBAL_KEY (self), FALSE);
	_tmp0_ = self->priv->_registered;
	result = _tmp0_;
	return result;
}


static void global_key_class_init (GlobalKeyClass * klass) {
	global_key_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GlobalKeyPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_global_key_get_property;
	G_OBJECT_CLASS (klass)->finalize = global_key_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GLOBAL_KEY_REGISTERED, g_param_spec_boolean ("registered", "registered", "registered", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("pressed", TYPE_GLOBAL_KEY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void global_key_instance_init (GlobalKey * self) {
	self->priv = GLOBAL_KEY_GET_PRIVATE (self);
	self->priv->_registered = FALSE;
}


static void global_key_finalize (GObject* obj) {
	GlobalKey * self;
	gboolean _tmp0_ = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GLOBAL_KEY, GlobalKey);
	_tmp0_ = self->priv->_registered;
	if (_tmp0_ == TRUE) {
		global_key_unregister (self);
	}
	G_OBJECT_CLASS (global_key_parent_class)->finalize (obj);
}


GType global_key_get_type (void) {
	return global_key_type_id;
}


GType global_key_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (GlobalKeyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) global_key_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GlobalKey), 0, (GInstanceInitFunc) global_key_instance_init, NULL };
	global_key_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "GlobalKey", &g_define_type_info, 0);
	return global_key_type_id;
}


static void _vala_global_key_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GlobalKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GLOBAL_KEY, GlobalKey);
	switch (property_id) {
		case GLOBAL_KEY_REGISTERED:
		g_value_set_boolean (value, global_key_get_registered (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



